from sage.functions.other import binomial, sqrt

def Narayana(n, k):
    return binomial(n, k-1)*binomial(n, k)/n

def NP(n, x):
    if n == 0:
        return x
    else:
        return sum(Narayana(n, k)*x ** k for k in range(1, n+1))

def T(z, t):
    return (1 - (z-t) - sqrt(1-2*(z+t)+(z-t) ** 2))/2

def L(z, w):
    return (1 - sqrt(1 - 4*z - 4*w + 4*z**2))/2
